<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\master_worker;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\master_worker\EngineerSettlementLists;
use app\adminapi\logic\master_worker\EngineerSettlementLogic;
use app\adminapi\validate\master_worker\EngineerSettlementValidate;
use excel\ExcelWriter;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;


/**
 * EngineerSettlement控制器
 * Class EngineerSettlementController
 * @package app\adminapi\controller
 */
class EngineerSettlementController extends BaseAdminController
{

    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function lists()
    {
        return $this->dataLists(new EngineerSettlementLists());
    }


    /**
     * @notes 添加
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function add()
    {
        //$params = (new EngineerSettlementValidate())->post();//->goCheck('add');
        try {
            $params = $this->request->post();
            $params = EngineerSettlementLogic::engineerSettlementValidate($params);
            $result = EngineerSettlementLogic::add($params,$this->adminId);
            if (true === $result) {
                return $this->success('添加成功', [], 1, 1);
            }
            return $this->fail(EngineerSettlementLogic::getError());
        } catch (\Exception $e) {
            return $this->fail($e->getMessage()?:EngineerSettlementLogic::getError());
        }
    }


    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function edit()
    {
        $params = (new EngineerSettlementValidate())->post()->goCheck('edit');
        $result = EngineerSettlementLogic::edit($params);
        if (true === $result) {
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(EngineerSettlementLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function delete()
    {
        $params = (new EngineerSettlementValidate())->post()->goCheck('delete');
        EngineerSettlementLogic::delete($params);
        return $this->success('删除成功', [], 1, 1);
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function detail()
    {
        $params = (new EngineerSettlementValidate())->goCheck('detail');
        $result = EngineerSettlementLogic::detail($params);
        return $this->data($result);
    }

    public function download()
    {
        $lists = EngineerSettlementLogic::downloadLists();
        (new ExcelWriter())->generateExcelFile([
            '工程师ID', '工程师编号', '工程师姓名', '工程师原始余额', '工程师总结算金额', '工程师扣款金额', '工程师最终结算金额', '结算时间', '结算明细备注'
        ], $lists,'template', ['master_worker_id','worker_number','engineer_name','original_balance','total_settlement_amount','deduction_amount',
            'final_settlement_amount','settlement_time','settlement_details_remarks']);
    }

}